/**
 * @author yu
 */
(function($){
		function _$(t){
		return $(t);
	}
	function render(t,p){
		var data = $.data(t, "star");
		var star = data.star;
		var cls=data.options.cls;
		if(cls!=''){
			star.addClass(cls);
		}		
		//data.options.onLoad.apply(t, arguments);

		renderStar(t);
		setMark(t);
		if(data.options.view==true){
			star.addClass('star-small');
			star.find('a').css("cursor","default")
			bindEvent2(t);
		}else{
			star.addClass('star-big');
			bindEvent(t);
		}
		data.isLoaded=true;
	}
	function bindEvent2(t){
		var data = $.data(t, "star");
		var star = data.star;
		star.delegate('a', 'click', function(e){
			e.preventDefault();
		})

	}
	function bindEvent(t){
		var data = $.data(t, "star");
		var star = data.star;
		star.delegate('a', 'mouseenter', function(){
			if(star.data('canMove')==false){
				return;
			}
			var link=$(this);
			var index=link.attr('index');
			var title=link.attr('title');
			star.find('.star-info').html(title);
			star.find('a').removeClass('star-mark');
			var stars=star.find('a:lt('+index+')');
			stars.addClass('star-mark');
		}) 
		star.delegate('a', 'click', function(e){
			e.preventDefault();
			var link=$(this);
			var index=link.attr('index');
			var title=link.attr('title');
			star.find('.star-info').html(title);
			star.find('a').removeClass('star-mark');
			var stars=star.find('a:lt('+index+')');
			stars.addClass('star-mark');
			star.data('canMove',false);
			setTimeout(function(){
				star.data('canMove',true);
			},500)
		})

	}
	function setMark(t){
		var data = $.data(t, "star");
		var star = data.star;
		var mark=data.options.mark;
		var stars=star.find('a:lt('+mark+')');
		stars.addClass('star-mark');
		var title=star.find('a.star-mark:last').attr('title');
		star.find('.star-info').html(title);
	}
	function renderStar(t){
		var data = $.data(t, "star");
		var star = data.star;
		var dom='<a href="javascript:;" index="1" title="非常不满意">' +
            '</a><a href="javascript:;" index="2" title="不满意">' +
            '</a><a href="javascript:;" index="3" title="一般">' +
            '</a><a href="javascript:;" index="4" title="满意"></a>' +
            '<a href="javascript:;" index="5" title="非常满意"></a>'
//		dom+='<span class="star-info"></span>'
		if(data.options.view==false){
//			dom+='<span class="star-info2"> </span>';
		}		
		star.append(dom);
	}
	function options(t,p){
		var data = $.data(t, "star");
		var opts=$.extend({},data.options,p);
		data.options=opts;
	}
	function getValue(t){
		var data = $.data(t, "star");
		var star = data.star;
		var index=star.find('a.star-mark:last').attr('index');		
		return parseInt(index);	
	}
	$.fn.star=function(o, p) {
		if( typeof o == "string") {
			return $.fn.star.methods[o](this, p);
		}
		o = o || {};
		return this.each(function() {
			var data = $.data(this, "star");
			var option;
			if(data) {
				option = $.extend(data.options, o);
			} else {
				option = $.extend({}, $.fn.star.defaults, $.fn.star.parseOptions(this),o);
				//$(this).attr("title", "star");
				data = $.data(this, "star", {
					options : option,
					star : _$(this),
					isLoaded : false
				});
			}
			render(this);			
	})}
	$.fn.star.methods={
		options:function(t,p){
			return t.each(function() {
				options(this, p);
			});
		},
		getValue:function(t){
			return getValue(t[0]);
		}
	}
	$.fn.star.parseOptions = function(t) {
		var t = $(t);
		return {}
	}
	$.fn.star.defaults = {
		cls:'',
		mark:0,
		view:false,
		onLoad:function(){}
	}
})(jQuery)
